#!/usr/bin/env node
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var sade_1 = tslib_1.__importDefault(require("sade"));
var add_bin_1 = require("./code-generation/add.bin");
var generate_bin_1 = require("./code-generation/generate.bin");
var install_bin_1 = require("./dependency/install.bin");
var build_bin_1 = require("./execution/build.bin");
var serve_bin_1 = require("./execution/serve.bin");
var test_bin_1 = require("./execution/test.bin");
var lint_bin_1 = require("./execution/lint.bin");
var submodules_bin_1 = require("./submodules/submodules.bin");
var workspaces_bin_1 = require("./workspaces/workspaces.bin");
var independency_bin_1 = require("./code-generation/independency.bin");
var messages_1 = require("../shared/messages");
var package_json_1 = tslib_1.__importDefault(require("../../package.json"));
var prog = sade_1.default('re-space');
console.log(messages_1.TITLE_CLI);
add_bin_1.addBinCommand(prog);
build_bin_1.buildBinCommand(prog);
independency_bin_1.independencyBinCommand(prog);
generate_bin_1.generateBinCommand(prog);
install_bin_1.installBinCommand(prog);
serve_bin_1.serveBinCommand(prog);
test_bin_1.testBinCommand(prog);
lint_bin_1.lintBinCommand(prog);
workspaces_bin_1.workspacesBinCommand(prog);
submodules_bin_1.submodulesBinCommand(prog);
prog.version(package_json_1.default.version).parse(process.argv);
