"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var execa_1 = tslib_1.__importDefault(require("execa"));
var utils_1 = require("../../shared/utils");
var submodules_helpers_1 = require("./submodules.helpers");
function submodulesBuildBinCommand(prog) {
    var _this = this;
    prog
        .command('submodules build')
        .describe('Build each submodule')
        .example('submodules build')
        // eslint-disable-next-line @typescript-eslint/ban-ts-ignore
        // @ts-ignore
        .alias('sb')
        .option('s, self', 'Apply build for the host workspace')
        .example('submodules build --self')
        .action(function (_a) {
        var self = _a.self;
        return tslib_1.__awaiter(_this, void 0, void 0, function () {
            var workspaceRootPath, cmd, submodulesExitCode, exitCode;
            return tslib_1.__generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, utils_1.findWorkspaceRootDir()];
                    case 1:
                        workspaceRootPath = _b.sent();
                        cmd = 'build';
                        return [4 /*yield*/, execa_1.default('git', ['submodule', 'foreach', 'yarn', cmd], {
                                stdio: [process.stdin, process.stdout, process.stderr],
                                cwd: workspaceRootPath
                            })];
                    case 2:
                        submodulesExitCode = (_b.sent()).exitCode;
                        console.log(submodules_helpers_1.finished({
                            cmd: cmd,
                            code: submodulesExitCode,
                            type: 'submodules'
                        }));
                        if (!self) return [3 /*break*/, 4];
                        console.log("\nEntering 'host'");
                        return [4 /*yield*/, execa_1.default('yarn', [cmd], {
                                stdio: [process.stdin, process.stdout, process.stderr],
                                cwd: workspaceRootPath
                            })];
                    case 3:
                        exitCode = (_b.sent()).exitCode;
                        console.log(submodules_helpers_1.finished({
                            cmd: cmd,
                            code: exitCode,
                            type: 'host'
                        }));
                        _b.label = 4;
                    case 4: return [2 /*return*/];
                }
            });
        });
    });
}
exports.submodulesBuildBinCommand = submodulesBuildBinCommand;
