"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var execa_1 = tslib_1.__importDefault(require("execa"));
var utils_1 = require("../../shared/utils");
var submodules_helpers_1 = require("./submodules.helpers");
function submodulesCheckoutBinCommand(prog) {
    var _this = this;
    prog
        .command('submodules checkout <branch>')
        .describe('Checkout each submodule on the specific branch')
        .example('submodules checkout branch-name')
        // eslint-disable-next-line @typescript-eslint/ban-ts-ignore
        // @ts-ignore
        .alias('sc')
        .option('s, self', 'Apply checkout for the host workspace')
        .example('submodules checkout branch-name --self')
        .action(function (branch, _a) {
        var self = _a.self;
        return tslib_1.__awaiter(_this, void 0, void 0, function () {
            var workspaceRootPath, cmd, submodulesExitCode, hostExitCode;
            return tslib_1.__generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, utils_1.findWorkspaceRootDir()];
                    case 1:
                        workspaceRootPath = _b.sent();
                        cmd = 'checkout';
                        return [4 /*yield*/, execa_1.default('git', ['submodule', 'foreach', 'git checkout', '-B', branch], {
                                stdio: [process.stdin, process.stdout, process.stderr],
                                cwd: workspaceRootPath
                            })];
                    case 2:
                        submodulesExitCode = (_b.sent()).exitCode;
                        console.log(submodules_helpers_1.finished({
                            cmd: cmd,
                            code: submodulesExitCode,
                            type: 'submodules'
                        }));
                        if (!self) return [3 /*break*/, 4];
                        console.log("\nEntering 'host'");
                        return [4 /*yield*/, execa_1.default('git', ['checkout', '-B', branch], {
                                stdio: [process.stdin, process.stdout, process.stderr],
                                cwd: workspaceRootPath
                            })];
                    case 3:
                        hostExitCode = (_b.sent()).exitCode;
                        console.log(submodules_helpers_1.finished({
                            cmd: cmd,
                            code: hostExitCode,
                            type: 'host'
                        }));
                        _b.label = 4;
                    case 4: return [2 /*return*/];
                }
            });
        });
    });
}
exports.submodulesCheckoutBinCommand = submodulesCheckoutBinCommand;
