"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("../utils");
var FeatureMessages = /** @class */ (function () {
    // eslint-disable-next-line no-empty-function
    function FeatureMessages() {
        this.exists = function () {
            return utils_1.error("\n    It seems like you already have this feature.\n        ");
        };
        this.invalidFeatureName = function (featureName) {
            var highlightedFeatureName = utils_1.inverse(" " + featureName + " ");
            return utils_1.error("\n  Invalid feature name\n  Unfortunately, re-space doesn't provide " + highlightedFeatureName + " feature\n        ");
        };
        this.adding = function (featureName) { return "Adding " + utils_1.info(featureName) + " feature..."; };
        this.successful = function (featureName) {
            return "Added " + utils_1.success(featureName) + " feature template";
        };
        this.failed = function (featureName) {
            return "Failed to add " + utils_1.error(featureName) + " feature template";
        };
    }
    return FeatureMessages;
}());
exports.FeatureMessages = FeatureMessages;
