"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var utils_1 = require("../utils");
var GenerateMessages = /** @class */ (function () {
    // shorthand
    // eslint-disable-next-line no-empty-function
    function GenerateMessages(packageName) {
        var _this = this;
        this.packageName = packageName;
        this.changePackageName = function (newPackageName) {
            _this.packageName = newPackageName;
        };
        this.copy = function () { return _this.packageName + "-copy"; };
        this.successful = function () { return "Generated " + utils_1.info(_this.packageName) + " package"; };
        this.generating = function () { return "Generating " + utils_1.info(_this.packageName) + " package..."; };
        this.failed = function () { return "Failed to generate " + utils_1.error(_this.packageName) + " package"; };
        this.successfulConfigure = function () { return 'The package successfully configured'; };
        this.failedConfigure = function () { return "Failed to fully configure the package"; };
        this.invalidTemplate = function (template) { return "Invalid template " + utils_1.error(template); };
        this.exists = function () {
            return "A folder named " + utils_1.error(_this.packageName) + " already exists! " + utils_1.bold('Choose a different name');
        };
        this.preparingPackage = function (packages) {
            var pkgText = packages.map(function (pkg) { return "     " + utils_1.info(pkg); }).join('\n');
            var requiredText = "Preparing " + utils_1.info(_this.packageName) + " package";
            return packages.length > 0
                ? requiredText + " with the following peer dependencies: \n" + pkgText + "\n"
                : requiredText;
        };
        this.preparedPackage = function (projectName) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            var commands;
            return tslib_1.__generator(this, function (_a) {
                commands = {
                    install: 're-space install',
                    start: 're-space serve',
                    build: 're-space build',
                    test: 're-space test'
                };
                return [2 /*return*/, "\n  " + utils_1.success('Awesome!') + " You're now ready to start coding.\n  \n  There is no need to run " + utils_1.info(commands.install) + ", since all peer dependencies are already in the workspace root\n  \n  So your next steps are:\n    " + utils_1.info("cd packages/" + projectName) + "\n  \n  To start developing (rebuilds the bundle on changes):\n    " + utils_1.info(commands.start) + "\n  \n  To build the bundle:\n    " + utils_1.info(commands.build) + "\n    \n  To test the package:\n    " + utils_1.info(commands.test) + "\n    \n  " + utils_1.highlight('Happy coding :)')];
            });
        }); };
    }
    return GenerateMessages;
}());
exports.GenerateMessages = GenerateMessages;
