"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var shelljs_1 = require("shelljs");
exports.safePackageName = function (name) {
    return name
        .toLowerCase()
        .replace(/(^@.*\/)|((^[^a-zA-Z]+)|[^\w.-])|([^a-zA-Z0-9]+$)/g, '');
};
function getAuthorName() {
    var author = '';
    author = shelljs_1.exec('npm config get init-author-name', {
        silent: true
    }).stdout.trim();
    if (author) {
        return author;
    }
    author = shelljs_1.exec('git config user.name', { silent: true }).stdout.trim();
    if (author) {
        setAuthorName(author);
        return author;
    }
    author = shelljs_1.exec('npm config get init-author-email', {
        silent: true
    }).stdout.trim();
    if (author) {
        return author;
    }
    author = shelljs_1.exec('git config user.email', { silent: true }).stdout.trim();
    if (author) {
        return author;
    }
    return author;
}
exports.getAuthorName = getAuthorName;
function setAuthorName(author) {
    shelljs_1.exec("npm config set init-author-name \"" + author + "\"", { silent: true });
}
exports.setAuthorName = setAuthorName;
exports.sortPackageJson = function () {
    return shelljs_1.exec('npx sort-package-json', { silent: true });
};
exports.buildPackage = function () { return shelljs_1.exec('yarn build', { silent: true }); };
exports.installDependencies = function () { return shelljs_1.exec('yarn install', { silent: true }); };
